type ('a, 'b) t =
  ('a * 'b) list

let empty =
  []

let mapi f env =
  List.map (fun (x, v) -> (x, f x v)) env

let cardinal t =
  List.length t

let bind key elt env =
  (key, elt) :: env

let rec lookup tyvar env =
  match env with
  | [] ->
      (*Format.printf "LOOKUP %d @." (List.length env) ;
        Printexc.print_raw_backtrace stdout (Printexc.get_callstack 12) ;
        flush stdout ;*)
      failwith "Not in the Env."
  | (x, v) :: xs ->
     if x = tyvar then v else lookup tyvar xs
